/*
 * (C) Copyright 2000-2002
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * (C) Copyright 2001 Sysgo Real-Time Solutions, GmbH <www.elinos.com>
 * Andreas Heppel <aheppel@sysgo.de>

 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <command.h>
#include <environment.h>
#include <linux/stddef.h>
#include <malloc.h>

#include "octeon_boot.h"

#ifdef CONFIG_SHOW_BOOT_PROGRESS
# include <status_led.h>
# define SHOW_BOOT_PROGRESS(arg)	show_boot_progress(arg)
#else
# define SHOW_BOOT_PROGRESS(arg)
#endif

#ifdef CONFIG_AMIGAONEG3SE
	extern void enable_nvram(void);
	extern void disable_nvram(void);
#endif

#undef DEBUG_ENV
#ifdef DEBUG_ENV
#define DEBUGF(fmt,args...) printf(fmt ,##args)
#else
#define DEBUGF(fmt,args...)
#endif

extern env_t *env_ptr;

extern void env_relocate_spec (void);
extern uchar env_get_char_spec(int);

//static char env_get_char_init (int index); // MATT
char env_get_char_init (int index);
char (*env_get_char)(int) = env_get_char_init;

#if defined(CONFIG_OCTEON_DYNAMIC_BOARD_DETECTION)
/* this struct supports the CONFIG_OCTEON_DYNAMIC_BOARD_DETECTION board specific environment variables */
typedef struct
{
    uint16_t board_type;
    char envVariable[40];
    char envValue[80];

} BOARD_SPECIFIC_EXTRA_ENV_TYPE;

#define BOARD_TYPE_ALL  0xffff
/* CONFIG_OCTEON_DYNAMIC_BOARD_DETECTION: Enter all  board specific env. var's in the table below */
static BOARD_SPECIFIC_EXTRA_ENV_TYPE board_specific_extra_env[] = 
{
    {CVMX_BOARD_TYPE_W5434, "ethact=", "octeth0"},
    {CVMX_BOARD_TYPE_W5650, "ethact=", "octeth1"},
    {CVMX_BOARD_TYPE_W5651X,"ethact=", "octeth0"},
    {CVMX_BOARD_TYPE_W63XX ,"ethact=", "octeth0"},
    {BOARD_TYPE_ALL, "mdio_alloc=", "yes"},
    {0, "",""}
};
#endif
/************************************************************************
 * Default settings to be used when no valid environment is found
 */
#define XMK_STR(x)	#x
#define MK_STR(x)	XMK_STR(x)

uchar default_environment[] = {
#ifdef	CONFIG_BOOTARGS
	"bootargs="	CONFIG_BOOTARGS			"\0"
#endif
#ifdef	CONFIG_BOOTCOMMAND
	"bootcmd="	CONFIG_BOOTCOMMAND		"\0"
#endif
#ifdef	CONFIG_RAMBOOTCOMMAND
	"ramboot="	CONFIG_RAMBOOTCOMMAND		"\0"
#endif
#ifdef	CONFIG_NFSBOOTCOMMAND
	"nfsboot="	CONFIG_NFSBOOTCOMMAND		"\0"
#endif
#if defined(CONFIG_BOOTDELAY) && (CONFIG_BOOTDELAY >= 0)
	"bootdelay="	MK_STR(CONFIG_BOOTDELAY)	"\0"
#endif
#if defined(CONFIG_BAUDRATE) && (CONFIG_BAUDRATE >= 0)
	"baudrate="	MK_STR(CONFIG_BAUDRATE)		"\0"
#endif
#if defined(CONFIG_DOWNLOAD_BAUDRATE) && (CONFIG_DOWNLOAD_BAUDRATE >= 0)
	"download_baudrate="	MK_STR(CONFIG_DOWNLOAD_BAUDRATE)		"\0"
#endif
#ifdef	CONFIG_LOADS_ECHO
	"loads_echo="	MK_STR(CONFIG_LOADS_ECHO)	"\0"
#endif
#ifdef	CONFIG_ETHADDR
	"ethaddr="	MK_STR(CONFIG_ETHADDR)		"\0"
#endif
#ifdef	CONFIG_ETH1ADDR
	"eth1addr="	MK_STR(CONFIG_ETH1ADDR)		"\0"
#endif
#ifdef	CONFIG_ETH2ADDR
	"eth2addr="	MK_STR(CONFIG_ETH2ADDR)		"\0"
#endif
#ifdef	CONFIG_IPADDR
	"ipaddr="	MK_STR(CONFIG_IPADDR)		"\0"
#endif
#ifdef	CONFIG_SERVERIP
	"serverip="	MK_STR(CONFIG_SERVERIP)		"\0"
#endif
#ifdef	CFG_AUTOLOAD
	"autoload="	CFG_AUTOLOAD			"\0"
#endif
#ifdef	CONFIG_PREBOOT
	"preboot="	CONFIG_PREBOOT			"\0"
#endif
#ifdef	CONFIG_ROOTPATH
	"rootpath="	MK_STR(CONFIG_ROOTPATH)		"\0"
#endif
#ifdef	CONFIG_GATEWAYIP
	"gatewayip="	MK_STR(CONFIG_GATEWAYIP)	"\0"
#endif
#ifdef	CONFIG_NETMASK
	"netmask="	MK_STR(CONFIG_NETMASK)		"\0"
#endif
#ifdef	CONFIG_HOSTNAME
	"hostname="	MK_STR(CONFIG_HOSTNAME)		"\0"
#endif
#ifdef	CONFIG_BOOTFILE
	"bootfile="	MK_STR(CONFIG_BOOTFILE)		"\0"
#endif
#ifdef	CONFIG_LOADADDR
	"loadaddr="	MK_STR(CONFIG_LOADADDR)		"\0"
#endif
#ifdef  CONFIG_CLOCKS_IN_MHZ
	"clocks_in_mhz=1\0"
#endif
#if defined(CONFIG_PCI_BOOTDELAY) && (CONFIG_PCI_BOOTDELAY > 0)
	"pcidelay="	MK_STR(CONFIG_PCI_BOOTDELAY)	"\0"
#endif
#ifdef  CONFIG_EXTRA_ENV_SETTINGS
	CONFIG_EXTRA_ENV_SETTINGS
#endif
	"\0"
};


void env_crc_update (void)
{
	env_ptr->crc = crc32(0, env_ptr->data, ENV_SIZE);
}

char env_get_char_init (int index)
{
	DECLARE_GLOBAL_DATA_PTR;
	uchar c;

	/* if crc was bad, use the default environment */
	if (gd->env_valid)
	{
		c = env_get_char_spec(index);
	} else {
		c = default_environment[index];
	}

	return (c);
}

#ifdef CONFIG_AMIGAONEG3SE
char env_get_char_memory (int index)
{
	DECLARE_GLOBAL_DATA_PTR;
	uchar retval;
	enable_nvram();
	if (gd->env_valid) {
		retval = ( *((uchar *)(gd->env_addr + index)) );
	} else {
		retval = ( default_environment[index] );
	}
	disable_nvram();
	return retval;
}
#else
char env_get_char_memory (int index)
{
	DECLARE_GLOBAL_DATA_PTR;

	if (gd->env_valid) {
		return ( *((uchar *)(gd->env_addr + index)) );
	} else {
		return ( default_environment[index] );
	}
}
#endif

char *env_get_addr (int index)
{
	DECLARE_GLOBAL_DATA_PTR;

	if (gd->env_valid) {
		return ( ((char *)(gd->env_addr + index)) );
	} else {
		return ((char *)&default_environment[index]);
	}
}
void env_default (void)
{
	DECLARE_GLOBAL_DATA_PTR;

	if (sizeof(default_environment) > ENV_SIZE)
	{
		puts ("*** Error - default environment is too large\n\n");
		return;
	}

	memset (env_ptr, 0, sizeof(env_t));


/* OCTEON TODO - real env handling in flash */


#if CONFIG_OCTEON_SIM && (!CONFIG_OCTEON_NO_BOOT_BUS)

#define OCTEON_ENV_FLASH_ADDR   (0x9FE00000UL)
#define OCTEON_ENV_FLASH_SIZE   (0x1000UL)

	if (*(uint32_t *)OCTEON_ENV_FLASH_ADDR)
	{
		printf("Copying user supplied environment from file flash\n");
		memcpy (env_ptr->data, (void *)OCTEON_ENV_FLASH_ADDR, OCTEON_ENV_FLASH_SIZE);
	}
	else
#endif /*  CONFIG_OCTEON_SIM && (!CONFIG_OCTEON_NO_BOOT_BUS)  */

	{
		/* use compiled in default env */
		memcpy (env_ptr->data, default_environment, sizeof(default_environment));

#if defined(CONFIG_OCTEON_DYNAMIC_BOARD_DETECTION)
        char *pEnv; 
        int i;
        char *local_env_variable, *local_env_value;
        int update_env_list;

        update_env_list = 0;

        /* point to the end of the default environment */
        pEnv = ((char *)&(env_ptr->data[0]) + sizeof(default_environment)) - 2;

        i=0;

        while (board_specific_extra_env[i].board_type != 0)
        {
            local_env_variable = board_specific_extra_env[i].envVariable;
            local_env_value = board_specific_extra_env[i].envValue;
            /* if this settingvariable applies to this board */
            if (board_specific_extra_env[i].board_type == gd->board_desc.board_type)
            {
                update_env_list = 1; /* time to update the list with this env setting */
            }
            else if (board_specific_extra_env[i].board_type == BOARD_TYPE_ALL)
            {
                if (!strcmp(board_specific_extra_env[i].envVariable, "mdio_alloc"))
                { 
                    /*we only set mdio_alloc to yes for boards with a Marvel phy (discreet RJ's) */
                    if ( !IS_10G_PHY_PRESENT && !IS_SFP_PRESENT )
                    {/* then we must have a PHY on board */
                        update_env_list = 1; /* time to update the list with this env setting */
                    }
                }
                else
                {
                    update_env_list = 1; /* time to update the list with this env setting */
                }
            }

            if (update_env_list)
            {
				/* copy this env setting to the end of the default env list */
				sprintf(pEnv, "%s%s",board_specific_extra_env[i].envVariable,board_specific_extra_env[i].envValue);
                /* add the length of each piece of the string */
                pEnv = pEnv + strlen(board_specific_extra_env[i].envVariable) + strlen(board_specific_extra_env[i].envValue);
                /* NULL terminate this entry */
                *pEnv = '\0';
                /* set the pointer to the next location for another environment variable */
                pEnv++;

                update_env_list = 0;/* clear the flag */
            }
            i++;
        }

#if defined(CONFIG_OCTEON_GEF_56XX_BOARD_GENERAL)
		int core_mask = 0;
		for (i=0; i<octeon_get_available_core_count(); i++) 
		{
			core_mask |= (1 <<i);
		}
		sprintf(pEnv, "swfb_cmd_arg=coremask=%4.4x", core_mask);
		/* add the length of each piece of the string */
		pEnv = pEnv + strlen("swfb_cmd_arg=coremask=") + 4;
		/* NULL terminate this entry */
        *pEnv = '\0';
        /* set the pointer to the next location for another environment variable */
        pEnv++;
#endif
        /* the env list needs to be NULL terminated */
        *pEnv = '\0';


#endif /* CONFIG_OCTEON_DYNAMIC_BOARD_DETECTION */
        
	}

#ifdef CONFIG_OCTEON_AT5810
	{
		char *pEnv;

		pEnv = ((char *)&(env_ptr->data[0]) + sizeof(default_environment)) - 2;
		if (cvmx_read_csr(CVMX_GPIO_RX_DAT) & 0x8000)
		{
			sprintf(pEnv, "bootfile=cavb.img", strlen("bootfile=cavb.img"));
			pEnv += strlen("bootfile=cavb.img") + 1;
		}
		else
		{
			sprintf(pEnv, "bootfile=cava.img", strlen("bootfile=cava.img"));
			pEnv += strlen("bootfile=cava.img") + 1;
		}
		/* Set numcores env variable to indicate the number of cores available */
		sprintf(pEnv,"numcores=%d", octeon_get_available_core_count());
	}
#endif

#ifdef CONFIG_OCTEON_TNPA5854
    setenv("numcores", "12");
#endif

#ifdef CFG_REDUNDAND_ENVIRONMENT
	env_ptr->flags = 0xFF;
#endif
	env_crc_update ();
	gd->env_valid = 1;
}

void env_relocate (void)
{
	DECLARE_GLOBAL_DATA_PTR;

	DEBUGF ("%s[%d] offset = 0x%lx\n", __FUNCTION__,__LINE__,
		gd->reloc_off);

#ifdef CONFIG_AMIGAONEG3SE
	enable_nvram();
#endif

#ifdef ENV_IS_EMBEDDED
	/*
	 * The environment buffer is embedded with the text segment,
	 * just relocate the environment pointer
	 */
	env_ptr = (env_t *)((ulong)env_ptr + gd->reloc_off);
	DEBUGF ("%s[%d] embedded ENV at %p\n", __FUNCTION__,__LINE__,env_ptr);
#else
	/*
	 * We must allocate a buffer for the environment
	 */
	env_ptr = (env_t *)malloc (CFG_ENV_SIZE);
	DEBUGF ("%s[%d] malloced ENV at %p\n", __FUNCTION__,__LINE__,env_ptr);
#endif

	/*
	 * After relocation to RAM, we can always use the "memory" functions
	 */
	env_get_char = env_get_char_memory;

	if (gd->env_valid == 0) {
#if defined(CONFIG_GTH)	|| defined(CFG_ENV_IS_NOWHERE)	/* Environment not changable */
		puts ("Using default environment\n\n");
#else
		puts ("*** Warning - bad CRC, using default environment\n\n");
		SHOW_BOOT_PROGRESS (-1);
#endif

		if (sizeof(default_environment) > ENV_SIZE)
		{
			puts ("*** Error - default environment is too large\n\n");
			return;
		}

		memset (env_ptr, 0, sizeof(env_t));


/* OCTEON TODO - real env handling in flash */


#if CONFIG_OCTEON_SIM_SETUP && (!CONFIG_OCTEON_NO_BOOT_BUS)
/* Special Simulator environment handling. */
#define OCTEON_ENV_FLASH_ADDR   (0x9FE00000UL)
#define OCTEON_ENV_FLASH_SIZE   (0x1000UL)

		if (*(uint32_t *)OCTEON_ENV_FLASH_ADDR)
		{
			printf("Copying user supplied environment from file flash\n");
			memcpy (env_ptr->data,
				(void *)OCTEON_ENV_FLASH_ADDR,
				OCTEON_ENV_FLASH_SIZE);
		}
		else
#endif
		{
			/* use compiled in default env */
            env_default();
        }


#ifdef CFG_REDUNDAND_ENVIRONMENT
		env_ptr->flags = 0xFF;
#endif
		env_crc_update ();
		gd->env_valid = 1;
	}
	else {
		env_relocate_spec ();
	}
	gd->env_addr = (ulong)&(env_ptr->data);

#ifdef CONFIG_AMIGAONEG3SE
	disable_nvram();
#endif
}

#ifdef CONFIG_AUTO_COMPLETE
int env_complete(char *var, int maxv, char *cmdv[], int bufsz, char *buf)
{
	int i, nxt, len, vallen, found;
	const char *lval, *rval;

	found = 0;
	cmdv[0] = NULL;

	len = strlen(var);
	/* now iterate over the variables and select those that match */
	for (i=0; env_get_char(i) != '\0'; i=nxt+1) {

		for (nxt=i; env_get_char(nxt) != '\0'; ++nxt)
			;

		lval = env_get_addr(i);
		rval = strchr(lval, '=');
		if (rval != NULL) {
			vallen = rval - lval;
			rval++;
		} else
			vallen = strlen(lval);

		if (len > 0 && (vallen < len || memcmp(lval, var, len) != 0))
			continue;

		if (found >= maxv - 2 || bufsz < vallen + 1) {
			cmdv[found++] = "...";
			break;
		}
		cmdv[found++] = buf;
		memcpy(buf, lval, vallen); buf += vallen; bufsz -= vallen;
		*buf++ = '\0'; bufsz--;
	}

	cmdv[found] = NULL;
	return found;
}
#endif
